;												
; RDS-Rohdatendecoder (Version-2)				
; Bernhard.Erfurt@gmx.de						
; 31.03.2014									
;												


; Anschlussbelegung PINS						
;												
; PB0 ==> OUT (TAKT)							
; PB1 ==> OUT (DATA)							
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> OUT DEMODULATOR						
; PC1 ==> 										
; PC2 ==> OUT TEST								
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> IN 57kHZ SIGNAL						
; PD3 ==> IN RDS SIGNAL							
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								

; ATmega8 										
.include "m8def.inc"


; EINGANG-A (57kHz)								
.equ EINGANGA_PIN_NR				= 2
.equ EINGANGA_PIN					= PIND
.equ EINGANGA_DDR					= DDRD
.equ EINGANGA_PORT					= PORTD
; EINGANG-B (RDS)								
.equ EINGANGB_PIN_NR				= 3
.equ EINGANGB_PIN					= PIND
.equ EINGANGB_DDR					= DDRD
.equ EINGANGB_PORT					= PORTD
; AUSGANG (TAKT)								
.equ AUSGANG_TAKT_PIN_NR			= 0
.equ AUSGANG_TAKT_PIN				= PINB
.equ AUSGANG_TAKT_DDR				= DDRB
.equ AUSGANG_TAKT_PORT				= PORTB
; AUSGANG (DATA)								
.equ AUSGANG_DATA_PIN_NR			= 1
.equ AUSGANG_DATA_DDR				= DDRB
.equ AUSGANG_DATA_PORT				= PORTB
; AUSGANG (DEMODULATOR)								
.equ AUSGANG_DEMODULATOR_PIN_NR		= 0
.equ AUSGANG_DEMODULATOR_DDR		= DDRC
.equ AUSGANG_DEMODULATOR_PORT		= PORTC
; AUSGANG (TEST)								
.equ AUSGANG_TEST_PIN_NR			= 2
.equ AUSGANG_TEST_DDR				= DDRC
.equ AUSGANG_TEST_PORT				= PORTC
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD

; Register										
.def ZAEHLER_ERROR	= R0
.def ZAEHLER_OK		= R1

.def SAMPLING 		= R2
.def SAMPLING_OLD 	= R3

.def SAMPLING_A		= R4
.def SAMPLING_B		= R5
.def DATA			= R6

.def NULL 			= R10
.def VOLL 			= R11

.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19


.def PHASE_POSITION	= R21
.def ZAEHLER		= R22





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0				

rjmp RESET      	 ; Reset Handler                           			  
rjmp INTERRUPT_ERROR ;rjmp EXT_INT0   ; IRQ0 Handler                      
rjmp INTERRUPT_ERROR ;rjmp EXT_INT1   ; IRQ1 Handler                      
rjmp INTERRUPT_ERROR ;rjmp TIM2_COMP  ; Timer2 Compare Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF   ; Timer2 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT  ; Timer1 Capture Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF   ; Timer1 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF	; Timer0 Overflow Handler             
rjmp INTERRUPT_ERROR ;rjmp SPI_STC    ; SPI Transfer Complete Handler     
rjmp INTERRUPT_ERROR ;rjmp USART_RXC  ; USART RX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp USART_UDRE ; UDR Empty Handler                 
rjmp INTERRUPT_ERROR ;rjmp USART_TXC  ; USART TX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp ADC        ; ADC Conversion Complete Handler   
rjmp INTERRUPT_ERROR ;rjmp EE_RDY     ; EEPROM Ready Handler              
rjmp INTERRUPT_ERROR ;rjmp ANA_COMP   ; Analog Comparator Handler         
rjmp INTERRUPT_ERROR ;rjmp TWSI       ; Two-wire Serial Interface Handler 
rjmp INTERRUPT_ERROR ;rjmp SPM_RDY    ; Store Program Memory Ready Handler


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR



RESET:                        
;STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
;													
	clr NULL
	ldi temp,255
	mov VOLL, temp
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp	
; PORT LED											
	; auf AUSGANG									
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT	
	; LEDs an										
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
; PORT EINGANG-A									
	cbi (EINGANGA_DDR),(EINGANGA_PIN_NR)		; auf EINGANG	
	sbi (EINGANGA_PORT),(EINGANGA_PIN_NR)		; PULL-UP ein	
; PORT EINGANG-B									
	cbi (EINGANGB_DDR),(EINGANGB_PIN_NR)		; auf EINGANG	
	sbi (EINGANGB_PORT),(EINGANGB_PIN_NR)		; PULL-UP ein	
; PORT AUSGANG DATA										
	sbi (AUSGANG_DATA_DDR),(AUSGANG_DATA_PIN_NR)			; auf AUSGANG	
	cbi (AUSGANG_DATA_PORT),(AUSGANG_DATA_PIN_NR)			; auf LOW		
; PORT AUSGANG TAKT										
	sbi (AUSGANG_TAKT_DDR),(AUSGANG_TAKT_PIN_NR)			; auf AUSGANG	
	cbi (AUSGANG_TAKT_PORT),(AUSGANG_TAKT_PIN_NR)			; auf LOW		
; PORT AUSGANG DEMODULATOR								
	sbi (AUSGANG_DEMODULATOR_DDR),(AUSGANG_DEMODULATOR_PIN_NR)			; auf AUSGANG	
	cbi (AUSGANG_DEMODULATOR_PORT),(AUSGANG_DEMODULATOR_PIN_NR)			; auf LOW		
; PORT AUSGANG TEST										
	sbi (AUSGANG_TEST_DDR),(AUSGANG_TEST_PIN_NR)			; auf AUSGANG	
	cbi (AUSGANG_TEST_PORT),(AUSGANG_TEST_PIN_NR)			; auf LOW		

; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; Interrupts aktivieren								
	sei
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	; 0...47
	inc ZAEHLER
	cpi ZAEHLER,(47+1)
	brlo LOOP_Z
	clr ZAEHLER
LOOP_Z:
;-------------------------------------------------------------------------------
LOOP_1:
	; warten, bis EINGANG LOW wird
	sbic (EINGANGA_PIN),(EINGANGA_PIN_NR)
	rjmp LOOP_1
;-------------------------------------------------------------------------------

	rcall DEMODULATOR
	rcall SAMPLING_POSITION_A
	rcall TAKT_DATA_GENERIEREN
	rcall SAMPLING_POSITION_B
	rcall APC

;-------------------------------------------------------------------------------
LOOP_2:
	; warten, bis EINGANG HIGH wird
	sbis (EINGANGA_PIN),(EINGANGA_PIN_NR)
	rjmp LOOP_2
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
DEMODULATOR:
	; PINZUSTAND ermitteln	
	sbic (EINGANGB_PIN),(EINGANGB_PIN_NR)
	rjmp DEMODULATOR_L
;-------------------------------------------------------------------------------
DEMODULATOR_H:
	sbi (AUSGANG_DEMODULATOR_PORT),(AUSGANG_DEMODULATOR_PIN_NR)			; auf HIGH		
	mov SAMPLING,VOLL
	rjmp PHASENWECHSEL_ERKENNUNG
;-------------------------------------------------------------------------------
DEMODULATOR_L:
	cbi (AUSGANG_DEMODULATOR_PORT),(AUSGANG_DEMODULATOR_PIN_NR)			; auf LOW		
	clr SAMPLING
	rjmp PHASENWECHSEL_ERKENNUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
PHASENWECHSEL_ERKENNUNG:
	cp SAMPLING,SAMPLING_OLD
	brne PHASENWECHSEL_ERKENNUNG_w
	ret
;-------------------------------------------------------------------------------
; Phasenwechsel erkannt															
PHASENWECHSEL_ERKENNUNG_w:
	mov SAMPLING_OLD,SAMPLING
	mov PHASE_POSITION,ZAEHLER	; POSITION merken	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAMPLING_POSITION_A:
	cpi ZAEHLER,5
	breq SAMPLING_POSITION_A_w
	ret
SAMPLING_POSITION_A_w:
	mov SAMPLING_A,SAMPLING
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TAKT_DATA_GENERIEREN:
	cpi ZAEHLER,23
	breq TAKT_DATA_GENERIEREN_w
	ret
TAKT_DATA_GENERIEREN_w:
	sbi (AUSGANG_TAKT_PORT),(AUSGANG_TAKT_PIN_NR)			; auf HIGH
;-------------------------------------------------------------------------------
	tst DATA
	breq DATA_L
DATA_H:
	sbi (AUSGANG_DATA_PORT),(AUSGANG_DATA_PIN_NR)			; auf HIGH	
	ret
DATA_L:
	cbi (AUSGANG_DATA_PORT),(AUSGANG_DATA_PIN_NR)			; auf LOW		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAMPLING_POSITION_B:
	cpi ZAEHLER,29
	breq SAMPLING_POSITION_B_w
	ret
SAMPLING_POSITION_B_w:
	mov SAMPLING_B,SAMPLING

	cp SAMPLING_A,SAMPLING_B
	breq SAMPLING_POSITION_DATA_H
SAMPLING_POSITION_DATA_L:
	clr DATA
	ret
SAMPLING_POSITION_DATA_H:
	mov DATA,VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Automatische PHASEN Control													
APC:
	; Zhler=47 ?	
	cpi ZAEHLER,47
	breq APC_w
	ret
;-------------------------------------------------------------------------------
APC_w:
	; TAKT			
	cbi (AUSGANG_TAKT_PORT),(AUSGANG_TAKT_PIN_NR)			; auf LOW		
	; Bereich Phasenwechsel definieren
	cpi PHASE_POSITION,(36)
	brlo APC_ERROR
;-------------------------------------------------------------------------------
APC_OK:
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	

	tst ZAEHLER_OK
	breq APC_OK_w	
	dec ZAEHLER_OK
	ret
APC_OK_w:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
APC_ERROR:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	

	ldi temp,(106)
	mov ZAEHLER_OK,temp

	dec ZAEHLER_ERROR	; -1	
	tst ZAEHLER_ERROR	; =0 ?	
	breq APC_ERROR_w
	ret
APC_ERROR_w:
	ldi ZAEHLER,1
	ldi temp,255
	mov ZAEHLER_ERROR,temp
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DECODER_SONSTIGES.asm"
.include "DECODER_WAIT_16MHZ.asm"		; 16 MHz	

